/*
    Spakes - a client/server Snakes-clone for up to 4 players
    Copyright (C) 2001, 2002, 2004  Markus Triska

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact me at triska@gmx.at
*/

#include <string>

#include "spakes.h"
#ifdef WINDOWS
#include <winsock.h>
#include "..\client\protocol.h"
#else
#include <sys/socket.h>
#include "../client/protocol.h"
#endif

#include "socket.h"

using namespace std;


int Socket::Readbyte(unsigned char &c)
{
	int numread;

	if (readpos >= writepos) {
		readpos = writepos = 0;
		if ( (numread = recv(sockfd, &data[writepos], 200, 0)) < 0) {
			return -1;
		} else if (numread == 0) {
			return 0;
		} else {
			writepos += numread;
		}
	}

	c = data[readpos++];
	return 1;
}

int Socket::Readline(std::string &retstring)
{
	int retval;
	unsigned char c;
	do {
		retval = Readbyte(c);
		// Return when error at start of new line (= no new packets)
		if ((retval < 0) && (retstring.size() == 0)) return retval;
		if (retval < 0) continue;  // Wait for complete packet
		if (retval == 0) return 0; // Connection closed

		retstring += c;
	} while (c != DELIMINATER);

	retstring[retstring.size() - 1] = 0;
	return 1;
}
